<template>
  <q-page id="PageCadastro">
    <div class="q-pa-md">
      <div class="q-gutter-md" style="max-width: 50%">
        <q-card class="my-card">
          <q-card-section>
            <div style="text-align: center">
              <label>CADASTRO DE USUÁRIO</label>
            </div>
            <q-separator />
            <br />
            <q-input
              v-model="usuario.nome"
              hint="Nome"
              :rules="[val => !!val || 'Campo Obrigatório']"
            />
            <q-input
              v-model="usuario.email"
              type="email"
              hint="Email"
              :rules="[val => !!val || 'Campo Obrigatório']"
            />
            <q-input
              v-model="usuario.senha"
              :type="isPwd ? 'password' : 'text'"
              hint="Senha"
              :rules="[val => !!val || 'Campo Obrigatório']"
            >
              <template v-slot:append>
                <q-icon
                  :name="isPwd ? 'visibility_off' : 'visibility'"
                  class="cursor-pointer"
                  @click="isPwd = !isPwd"
                />
              </template>
            </q-input>
            <br />
            <br />
            <q-btn color="primary" label="Adicionar" @click="adicionar" />
            <br />
            <template>
              <div class="q-pa-md" v-if="usuarios.length > 0">
                <q-table
                  title="Usuarios"
                  :data="usuarios"
                  :columns="columns"
                  row-key="nome"
                  selection="single"
                  :selected.sync="selecionado"
                />
              </div>
            </template>
            <br />
            <div class="row" v-if="this.selecionado.length > 0">
              <q-btn
                color="deep-orange"
                glossy
                label="Excluir"
                @click="modalExcluir"
              />
            </div>
          </q-card-section>
        </q-card>
      </div>
    </div>
    <q-dialog v-model="confirm" persistent>
      <q-card>
        <q-card-section class="row items-center">
          <i class="material-icons">delete</i>
          <span class="q-ml-sm"
            >Deseja exclui o usuario selecionado {{ this.usuarioSelecionado }}?
          </span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancelar" color="primary" v-close-popup />
          <q-btn
            flat
            label="Excluir"
            color="primary"
            v-close-popup
            @click="excluir"
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "PageCadastro",
  data() {
    return {
      isPwd: true,
      confirm: false,
      usuario: {
        nome: null,
        senha: null,
        email: null
      },
      usuarios: [],
      selecionado: [],
      usuarioSelecionado: null,
      columns: [
        {
          name: "nome",
          required: true,
          label: "Nome",
          align: "left",
          field: "nome",
          sortable: true
        },
        {
          name: "email",
          align: "center",
          label: "Email",
          field: "email",
          sortable: true
        }
      ]
    };
  },
  computed: {},
  watch: {},
  created: function() {
    this.usuarios = this.$q.localStorage.getItem("usuarios");
  },
  methods: {
    salvar() {
      this.$q.localStorage.set("usuarios", this.usuarios);
    },
    excluir() {
      this.usuarios.splice(this.usuarios.indexOf(this.selecionado[0]), 1);
      this.salvar();
      this.selecionado = [];
    },
    modalExcluir() {
      this.confirm = true;
      if (this.selecionado.length > 0) {
        this.usuarioSelecionado = this.selecionado[0].nome;
      }
    },
    adicionar() {
      if (
        this.usuario.nome != null &&
        this.usuario.senha != null &&
        this.usuario.email != null
      ) {
        this.usuarios.push(this.usuario);
        this.salvar();
        this.limpar();
      }
    },
    limpar() {
      this.usuario = { nome: null, senha: null, email: null };
    }
  },
  mounted() {}
};
</script>

<style>
#PageCadastro {
  padding: 20px;
}
#PageCadastro .number {
  font-weight: 500;
  font-size: 30px;
}
</style>
